from ngsolve import *
from netgen.geom2d import unit_square

mesh = Mesh(unit_square.GenerateMesh(maxh=2, quad_dominated=True))
mesh.Refine()

#flag = "one"  # BFI for a single FESpace
flag = "two"  # BFI for two FESpaces
fes = L2(mesh)
fes2 = L2(mesh, order=1)
v = fes.TrialFunction()
if flag == "one" :
    w = fes.TestFunction()
    a = BilinearForm(fes)
    app = GridFunction(fes)
else :
    w = fes2.TestFunction()
    a = BilinearForm(fes, fes2)
    app = GridFunction(fes2)

### FIXME
a += SymbolicBFI(v.Other(bnd = 0)*w, element_boundary=True)
#a += SymbolicBFI(v*w, element_boundary=True)
#a += SymbolicBFI(v*w, skeleton=True)
#a += SymbolicBFI(v.Other()*w, skeleton=True)

g = GridFunction(fes)
g.Set(CoefficientFunction(1))

a.Apply(g.vec, app.vec)
print(app.vec[0:4])
input("done")
